﻿# fuelle-tiefensuche-ganz-kurz.py
# rekursives Programm zum Füllen eines Containers mit Tiefensuche
# (Rucksackproblem)
# Diese Variante ist natürlich schon optimiert, da die Rekursion
# abgebrochen wird, sobald der Container zu voll wird.
# Im Vergleich mit der entsprechenden Lösung mit Scheme
# ist wichtig, dass Python ebenfalls Rückgabewerte in
# Bedingungen akzeptiert, die nicht True oder False sind.
# Weiterhin ist wichtig, dass bei den rekursiven Aufrufen
# die Variablen neu angelegt werden und so nicht die Werte
# der aufrufenden Rekursionsstufe verändert werden.


# Globale Variable für die Stücke:
stuecke=[30,30,30,30,30,20,20,20,20,20]

def fuelle(stuecke, container, fassungsvermoegen):
    if fassungsvermoegen==sum(container):
        return container
    if len(stuecke)==0:
        return False
    if fassungsvermoegen<sum(container):
        return False
    ergebnis=fuelle(stuecke[1:], container+stuecke[:1], fassungsvermoegen)
    if ergebnis:
        return ergebnis
    else:
        return fuelle(stuecke[1:], container, fassungsvermoegen)

### Tests
def ausgabe(stuecke, fassungsvermoegen):
    print('Stücke:', stuecke, fassungsvermoegen,
          'Ergebnis:\n', fuelle(stuecke, [], fassungsvermoegen), '\n')


ausgabe( stuecke, 80)
ausgabe( stuecke, 90)
ausgabe( stuecke, 100)
ausgabe( stuecke+[30], 100)
ausgabe( [30,30,30,30], 100)
##ausgabe( stuecke*10, 100)
##ausgabe( stuecke*10, 1000)
##ausgabe( [30,30,20,20], 50)

