﻿# fuelle-tiefensuche-tiefe-Liste.py
# rekursives Programm zum Füllen eines Containers mit Tiefensuche
# (Rucksackproblem)
# Diese Variante ist natürlich schon optimiert, da die Rekursion
# abgebrochen wird, sobald der Container zu voll wird.
# Im Vergleich mit der entsprechenden Lösung mit Scheme
# ist wichtig, dass Python ebenfalls Rückgabewerte in
# Bedingungen akzeptiert, die nicht True oder False sind.
# Weiterhin ist wichtig, dass bei den rekursiven Aufrufen
# die Objekte neu angelegt werden und so nicht die Werte
# der aufrufenden Rekursionsstufe verändert werden.


# Globale Variable für die Stücke:
stuecke=[30,30,30,30,30,20,20,20,20,20]
def erzeuge_Container(fassungsvermoegen):
    return [fassungsvermoegen, []]

def fuelle_ein(stueck, container):
    inhalt=[]+container[1] # echte Kopie erzeugen!
    inhalt.append(stueck)
    return [container[0], inhalt]

# Prädikat zum Testen, ob der Container voll ist.
def ist_voll(container):
    return container[0]==sum(container[1])

def wird_zu_voll(stueck, container):
    return container[0]<stueck+sum(container[1])

def fuelle(stuecke, container):
    ##input(str((stuecke,container))) ## zum Verfolgen des Ablaufs
    if ist_voll(container):
        return container
    elif len(stuecke)==0:
        return False
    elif wird_zu_voll(stuecke[0], container):
        return False
##    else:
##        ergebnis=fuelle(stuecke[1:],fuelle_ein(stuecke[0], container))
##        if ergebnis:
##            return ergebnis
##        else:
##            return fuelle(stuecke[1:], container)
### "einfachere" Alternative:
    ergebnis=fuelle(stuecke[1:],fuelle_ein(stuecke[0], container))
    if ergebnis:
        return ergebnis
    else:
        return fuelle(stuecke[1:], container)


### Tests
def ausgabe(stuecke, fassungsvermoegen):
    print('Stücke:', stuecke, fassungsvermoegen,
          'Ergebnis:\n', fuelle(stuecke, [fassungsvermoegen, []] ), '\n')


ausgabe( stuecke, 80)
ausgabe( stuecke, 90)
ausgabe( stuecke, 100)
ausgabe( stuecke*10, 100)
ausgabe( stuecke*10, 1000)
ausgabe( [30,30,20,20], 50)
